import {
  UserCtor,
  UserInfo,
  UserInfoWithPassword,
  UserWithPasswordCtor,
} from '@core';
import { generateHash } from '../functions/password';
import { Entity } from './entity';

export class User extends Entity implements UserInfo {
  username: string;

  constructor(raw: UserCtor) {
    super(raw);

    this.username = raw.username ? raw.username : '';
  }

  Info(): UserInfo {
    return {
      uuid: this.uuid,
      username: this.username,
    };
  }
}

export class UserWithPassword extends User implements UserInfoWithPassword {
  password: string;

  constructor(raw: UserWithPasswordCtor) {
    super(raw);

    this.password = generateHash(this.uuid, raw.password || '');
  }

  Info(): UserInfoWithPassword {
    return {
      uuid: this.uuid,
      username: this.username,
      password: this.password,
    };
  }
}
