import { EntityInfo } from './entity';

export type UserInfo = {
  uuid: string;
  username: string;
};

export type UserInfoWithPassword = {
  password: string;
} & UserInfo;

export type User = UserInfo & EntityInfo;

export type UserWithPassword = UserInfoWithPassword & EntityInfo;

export type CreateUserBody = {
  username: string;
  password: string;
};

export type LoginUserBody = {
  username: string;
  password: string;
};

export type UserCtor = Partial<User>;

export type UserWithPasswordCtor = Partial<UserWithPassword>;
